//Titel:            Testbeispuiel fuer Design Pattern Singleton
//Version:          2.0 07.11.2010
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf.(TU) Dipl.-Ing.(FH) Michael Wilhelm//Firma:
//Beschreibung:     Erster Versuch  mit getInstance


// Design Pattern Singleton
// Stellt sicher, dass nur eine Instanz existiert
// dazu wird der Default-Konstrutor als private bzw. protected definiert
// die Erzeugung ist leider nicht Thread-sicher

// Beispiel mit Ausgabe

import java.io.*;



public class Singleton2 {
    private static Singleton2 instance;

    private int a=42;
    protected Singleton2(int b) {
       this.a = b;
    }

    public int getValue(){
      return a;
    }

    public void setValue(int value) {
      a = value;
    }

    public static Singleton2 getInstance(){
      if (instance == null) {
         instance = new Singleton2(4711);
      }
      return instance;
    } 



   private static void pause() {
    try {
      System.in.read();
    }
    catch (IOException e) {
    }
  }  // pause



 static public void main(String[] args) {
     System.out.println(" ");
     System.out.println(" ");
    
    Singleton2 a = Singleton2.getInstance();
    System.out.println("a: "+ a.getValue()  );
    a.setValue(2222);
    System.out.println(" ");
    System.out.println(" ");
    
    Singleton2 b = Singleton2.getInstance();
    b.setValue(1111);
    System.out.println("a: "+ a.getValue()  );
    System.out.println("b: "+ b.getValue()  );
    System.out.println(" ");
     pause();
 }


}
