//Titel:            Testbeispuiel fuer Design Pattern Singleton
//Version:          2.0 07.11.2010
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf.(TU) Dipl.-Ing.(FH) Michael Wilhelm//Firma:
//Beschreibung:     Zweiter Versuch  mit getInstance, mit synchronized


// Design Pattern Singleton
// Stellt sicher, dass nur eine Instanz existiert
// dazu wird der Defautl-Konstrutor als private bzw. protected definiert
// die synchronized-Anweisung stellt die Einzigartigkeit sicher

// Beispiel mit Test-Ausgabe
// a und b sind gleiche Instanzen

import java.io.*;



public class Singleton3 {
    private static Singleton3 instance = null;
    private int i;

    protected Singleton3(int i) {
      this.i = i;
    }


    public static Singleton3 getInstance(){
         if (instance == null) {
             synchronized(Singleton3.class) {
                if (instance == null) {
                     instance = new Singleton3(4711);
                }
             }
         }
         return instance;
    }


    public int getValue() {
      return i;
    }
    public void setValue(int value) {
      i = value;
    }

   private static void pause() {
    try {
      System.in.read();
    }
    catch (IOException e) {
    }
  }  // pause



 static public void main(String[] args) {
		System.out.println(" ");
		System.out.println(" ");

	 Singleton3 a = Singleton3.getInstance();

   System.out.println("a: "+ a.getValue()  );
		System.out.println(" ");
		System.out.println(" ");

	 Singleton3 b = Singleton3.getInstance();
   b.setValue(1111);
   System.out.println("a: "+ a.getValue()  );
   System.out.println("b: "+ b.getValue()  );
   System.out.println(" ");

   pause();
 }

 
}
