//Titel:            Testbeispuiel fuer Design Pattern Singleton
//Version:          2.0 07.11.2010
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf.(TU) Dipl.-Ing.(FH) Michael Wilhelm//Firma:
//Beschreibung:     Dritter Versuch  mit getInstance, static Erzeugung


// Design Pattern Singleton
// Stellt sicher, dass nur eine Instanz existiert
// dazu wird der Default-Konstrutor als private bzw. protected definiert
// durch die statische Erzeugung ist diese Variante Thread-sicher

// Beispiel mit Test-Ausgabe
// a und b sind gleiche Instanzen

import java.io.*;



public class Singleton4 {
    private static Singleton4 instance = new Singleton4(2);
    private int i=33;

    protected Singleton4(int i) {
      System.out.println("i im Konstruktor: "+this.i);
      this.i = i;
    }
    public static Singleton4 getInstance(){
         return instance;
    }
    public int getValue() {
      return i;
    }
    public void setValue(int value) {
      i = value;
    }

   private static void pause() {
    try {
      System.in.read();
    }
    catch (IOException e) {
    }
  }  // pause



 static public void main(String[] args) {
    System.out.println(" ");
    System.out.println(" ");
    
    Singleton4  a  = Singleton4.getInstance();
    System.out.println("a: "+ a.getValue()  );
    a.setValue(2222);
    System.out.println(" ");
    System.out.println(" ");
    
    Singleton4  b = Singleton4.getInstance();
    b.setValue(1111);
    System.out.println("a: "+ a.getValue()  );
    System.out.println("b: "+ b.getValue()  );
    System.out.println(" ");
    test();
    pause();
 }

 static void test() {
	 Singleton4  c = Singleton4.getInstance();
     System.out.println("c: "+ c.getValue()  );
 }

}
