//Titel:            Testbeispuiel fuer Design Pattern Singleton
//Version:          2.0 07.11.2010
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf.(TU) Dipl.-Ing.(FH) Michael Wilhelm//Firma:
//Beschreibung:     Static Erzeugung, getInstance, MDI Fenster


// einfaches Beispiel eines Internal Frame
// mit New einfgen
// Verwendet eine Singleton-Klasse als "globale Variable"
// Internes Fenster zur Demonstration des Singleton-Pattern
// Mit dem Schalter "Set" wird die Variable gesetzt
// er sollte dann in alle anderen Fenstern zu sehen sein
// das geht ueber den Schalter Check

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;



public class Singleton5 extends JFrame {

  private JDesktopPane desktopPane = new JDesktopPane();

  private JTextField TGlobal;
  private JButton BnSetValue;

  private int _anzFrames=0;

  mySingleton _Single;

  JMenuBar menuBar1 = new JMenuBar();
  JMenu MainFile = new JMenu();
  JMenuItem MnNew = new JMenuItem();
  JMenuItem MnClose = new JMenuItem();

  public Singleton5() {
    this.setSize( 800, 600);
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setGUI();
  }

  public void setGUI() {
    this.getContentPane().setLayout( new BorderLayout() );
//    this.setContentPane(desktopPane);

    TGlobal = new JTextField("");
    TGlobal.setFont(new java.awt.Font("Dialog", 0, 30));
    BnSetValue = new JButton("SetValue");
    JPanel panel1 = new JPanel();
    panel1.setLayout( new GridBagLayout() );
    panel1.add(BnSetValue, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0,20,0,0), 0, 6));

    panel1.add(TGlobal,   new GridBagConstraints(1, 0, 3, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0,20,0,20), 22, 6));

    this.getContentPane().add(panel1, BorderLayout.NORTH );
    this.getContentPane().add(desktopPane, BorderLayout.CENTER );

    BnSetValue.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        BnSetValue_click();  // !!!!!!
      }
    });

    setMenus();
    _Single = mySingleton.getInstance();
  } // setGUI


  private  void setMenus() {
    // Men Datei
    MainFile.setText("Datei");

    MnNew.setText("Neue Datei");
    MnNew.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnNew_actionPerformed(e);
      }
    });
    MnNew.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
    MainFile.add(MnNew);



    // --------------------------
    MnClose.setText("Schlieen");
    MnClose.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnClose_actionPerformed(e);
      }
    });
    MainFile.add(MnClose);


    menuBar1.add(MainFile);





    this.setJMenuBar(menuBar1);
  } // setMenus
  static public void main(String[] args) {
    Singleton5 frame = new Singleton5();
    frame.setVisible(true);
  }


  void BnSetValue_click() {
    String s =TGlobal.getText();
    _Single.setValue( s );
  }

  void MnNew_actionPerformed(ActionEvent e) {
    MyInternalFrame frame = new MyInternalFrame();
    _anzFrames++;
    frame.setBounds( _anzFrames*80, _anzFrames*80, 450, 300);
    desktopPane.add(frame, new Integer(1));
    frame.toFront();

  }

  void MnClose_actionPerformed(ActionEvent e) {
    System.exit(0);
  }


}  // Singleton5


// Internes Fenster zur Demonstration des Singleton-Pattern
// Mit dem Schalter "Set" wird die Variable gesetzt
// er sollte dann in alle anderen Fenstern zu sehen sein
// das geht ueber den Schalter Check
class MyInternalFrame extends JInternalFrame {
  JLabel jLabel1 = new JLabel();

  mySingleton _Single = mySingleton.getInstance();

  public MyInternalFrame() {
    setGUI();
    setVisible(true);
  }

  public void setGUI() {
    this.setClosable(true);
    this.setIconifiable(true);
    this.setMaximizable(true);
    this.setResizable(true);
    this.getContentPane().setLayout(  new BorderLayout() );

    JToolBar toolBar = new JToolBar();
    JButton BnCheck = new JButton("Check");
    toolBar.add(BnCheck);
    BnCheck.setFont(new java.awt.Font("Dialog", 0, 30));


    BnCheck.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BnCheck_click();  // !!!!!!
      }
    });


    this.getContentPane().add(toolBar, BorderLayout.NORTH);

    jLabel1.setText("jLabel1");
    jLabel1.setFont(new java.awt.Font("Dialog", 0, 30));
    jLabel1.setFont(new java.awt.Font("Dialog", 0, 30));
    this.getContentPane().add(jLabel1, BorderLayout.CENTER);

  }

  void BnCheck_click() {
    jLabel1.setText( _Single.getValue() );
  }

}



class mySingleton {
    private static mySingleton instance = new mySingleton("noname");
    private String _s;

    protected mySingleton(String s) {
      _s = s;
    }

     // hiermit Thread sicher
    public static mySingleton getInstance(){
      return instance;
    }


    public String getValue() {
      return _s;
    }
    public void setValue(String value) {
      _s = value;
    }
}  // mySingleton

